#include "StdAfx.h"
#include ".\abstractmimic.h"

IMPLEMENT_RTTI(INMiniMapCtrlUI, IComponentUI)

CAbstractMimic::CAbstractMimic(void)
{
}

CAbstractMimic::~CAbstractMimic(void)
{
}
void CAbstractMimic::AddMimicListener(IMimicListener* pListener)
{
	ATLASSERT(pListener!=NULL);
	ATLASSERT(m_lstMimicListener.Find(pListener) == NULL);
	m_lstMimicListener.AddTail(pListener);
}
void CAbstractMimic::RemoveMimicListener(IMimicListener* pListener)
{
	ATLASSERT(pListener!=NULL);
	POSITION pos = m_lstMimicListener.Find(pListener);
	if (pos)
	{
		m_lstMimicListener.RemoveAt(pos);		
	}
}
void CAbstractMimic::Fire_OnChangeMimic()
{
	POSITION pos = m_lstMimicListener.GetHeadPosition();
	while (pos)
	{
		IMimicListener* pMimicListener = m_lstMimicListener.GetNext(pos);
		if (pMimicListener)
		{
			pMimicListener->OnChangeMimic();
		}
	}
}
void CAbstractMimic::Fire_OnPaintMimic(BOOL bRedraw)
{
	POSITION pos = m_lstMimicListener.GetHeadPosition();
	while (pos)
	{
		IMimicListener* pMimicListener = m_lstMimicListener.GetNext(pos);
		if (pMimicListener)
		{
			pMimicListener->OnPaintMimic(bRedraw);
		}
	}
}